unit SE_classes;
{$mode objfpc}{$H+}

interface

 uses  Classes, SysUtils,  BaseUnix, LCLIntf, strings;

 Const Op_NeuAnlegen = O_TRUNC;
       Op_Open  = 0;

 Type
 TFile = class(TObject)
   private
      FHandle  : cint;
    protected
      Name     : PAnsiChar;
    public
      constructor CreateFil(FileName: PAnsiChar; Mode : Word);  reintroduce;
      destructor Destroy; reintroduce;
      function	Seek(Offset: Integer): Integer;
      procedure Seek_0 ;
      function	Read(var Buffer;Len:Integer): DWORD;
      function	ReadInt(var Buffer): DWORD;
      function	Write(const Buffer;Len:Integer): DWORD;
 end;

 Var DatIsNeu: Boolean;

   implementation

uses LCLType;

//TFile.TFile.TFile.TFile.TFile.TFile.TFile.TFile.TFile.TFile.TFile.TFile.TFile.TFile.TFile.TFile.TFile.TFile.
constructor TFile.CreateFil(FileName: PAnsiChar; Mode : Word);
Var Flag : Integer;
begin
  Name := StrNew(FileName);
  Flag := O_RDWR or Mode;
  DatIsNeu := false;
  FHandle := FpOpen(FileName,Flag);
  if FHandle < 1 then begin  //wenn nicht möglich dann ...
    DatIsNeu := true;
    Flag := Flag or O_CREAT;
    FHandle := FpOpen(FileName, Flag);
  end;
end;

destructor TFile.Destroy;
begin
  if FHandle > 0 then  fpclose(FHandle);
  StrDispose(Name);
end;

function TFile.Seek(Offset: Integer): Integer;
begin
  Result := FileSeek(FHandle, Offset , fsFromBeginning);
end;

procedure TFile.Seek_0;
begin
  FileSeek(FHandle, 0, fsFromBeginning);
end;

function TFile.Read(var Buffer;Len:Integer): DWORD;
begin
  Result :=  FpRead(FHandle, Buffer, Len);
end;

function TFile.ReadInt(var Buffer): DWORD;
begin
  Result :=  FpRead(FHandle, Buffer, 4);
end;

function TFile.Write(const Buffer; Len:Integer): DWORD;
begin
  Result := FpWrite( FHandle, Buffer, Len);
end;


end.

